using System;
using System.Drawing.Drawing2D;
using System.Drawing.Imaging;

namespace DemoImage
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        //ת
        private void button1_Click(object sender, EventArgs e)
        {
            if (string.IsNullOrWhiteSpace(txt_path.Text))
            {
                MessageBox.Show("ѡͼƬ");
                return;
            }
            var ext = Path.GetExtension(txt_path.Text);
            var filename = Path.GetFileName(txt_path.Text);
            filename = filename.Substring(0, filename.LastIndexOf('.'));
            Image img = Image.FromFile(txt_path.Text);
            var dirpath = Application.StartupPath + "newImages";
            if (!Directory.Exists(dirpath)) Directory.CreateDirectory(dirpath);
            if (cb_type.SelectedText != "Ĭ")
            {
                ext = cb_type.SelectedItem.ToString().Substring(cb_type.SelectedItem.ToString().LastIndexOf('.'));
            }
            var filepath = dirpath + "/" + filename + ext;
            if (File.Exists(filepath)) File.Delete(filepath);

            ImageTransformation(img, filepath, GetT<ImageFormatEnum>(trackBar1.Value), trackBar2.Value);

            img.Dispose();
            img = null;
            MessageBox.Show("ѹ");
        }

        /// <summary>
        /// ͼƬת
        /// </summary>
        /// <param name="image"></param>
        /// <param name="directoryPath">Ŀ¼·</param>
        /// <param name="imageenum"></param>
        /// <param name="qualityNum">ͼƬ</param>
        public void ImageTransformation(Image image, string directoryPath, ImageFormatEnum imageenum = ImageFormatEnum._1080, long qualityNum = 100)
        {
            var ext = Path.GetExtension(directoryPath);
            ext = ext.Substring(ext.LastIndexOf('.') + 1);  //ȥ .jpeg  =>   jpeg
            int oldWidth = image.Width;
            int oldHeight = image.Height;

            int newWidth = 0;
            int newHeight = 0;

            if (oldWidth > oldHeight && oldWidth > (int)imageenum)
            {
                newWidth = (int)imageenum;
                newHeight = Convert.ToInt32(oldHeight * newWidth / oldWidth);
            }
            else if (oldHeight > oldWidth && oldHeight > (int)imageenum)
            {
                newHeight = (int)imageenum;
                newWidth = Convert.ToInt32(oldWidth * newHeight / oldHeight);
            }
            else if (oldWidth == oldHeight && oldWidth > (int)imageenum)
            {
                newHeight = (int)imageenum;
                newWidth = Convert.ToInt32(oldWidth * newHeight / oldHeight);
            }
            else
            {
                newWidth = Convert.ToInt32(oldWidth);
                newHeight = Convert.ToInt32(oldHeight);
            }

            //½ͼƬ
            Image newimage = new Bitmap(newWidth, newHeight);
            //½
            Graphics g = Graphics.FromImage(newimage);
            //ջñɫ
            g.Clear(Color.Transparent);
            //ûĻ滭
            g.CompositingQuality = CompositingQuality.HighQuality;
            //ø,ٶȳƽ̶
            g.SmoothingMode = SmoothingMode.HighQuality;
            //øֵ
            g.InterpolationMode = InterpolationMode.HighQualityBilinear;
            //ʾͼλ
            Rectangle destRect = new Rectangle(0, 0, newWidth, newHeight);
            //ʾͼһ
            Rectangle srcRect = new Rectangle(0, 0, image.Width, image.Height);
            g.DrawImage(image, destRect, srcRect, GraphicsUnit.Pixel);
            g.Dispose();

            //´ΪͼƬʱ,ѹ
            EncoderParameters encoderParams = new EncoderParameters();
            EncoderParameter encoderParam = new EncoderParameter(Encoder.Quality, qualityNum);
            encoderParams.Param[0] = encoderParam;
            //var format = GetImageFormat(image).ToString().ToLower();
            //var encoder = GetEncoderInfo("image/" + format);
            var encoder = GetEncoderInfo("image/" + ext);
            newimage.Save(directoryPath, encoder, encoderParams);
            newimage.Dispose();
            newimage = null;
        }

        private static ImageCodecInfo GetEncoderInfo(string mimeType)
        {
            int j;
            ImageCodecInfo[] encoders;
            encoders = ImageCodecInfo.GetImageEncoders();
            for (j = 0; j < encoders.Length; ++j)
            {
                if (encoders[j].MimeType == mimeType)
                    return encoders[j];
            }
            return null;
        }
        /// <summary>
        /// ͼƬʽ
        /// </summary>
        public enum ImageFormatEnum
        {
            _640 = 640,
            _800 = 800,
            _1024 = 1024,
            _1080 = 1080,
            _1920 = 1920,
            _2560 = 2560,
            _b = 0      //ԭͼ
        }


        /// <summary>
        ///ȡͼƬʽ
        /// </summary>
        /// <param name="img">ͼƬ</param>
        /// <returns>ĬϷJPEG</returns>
        public ImageFormat GetImageFormat(Image img)
        {
            if (img.RawFormat.Equals(ImageFormat.Jpeg))
            {
                return ImageFormat.Jpeg;
            }
            if (img.RawFormat.Equals(ImageFormat.Gif))
            {
                return ImageFormat.Gif;
            }
            if (img.RawFormat.Equals(ImageFormat.Png))
            {
                return ImageFormat.Png;
            }
            if (img.RawFormat.Equals(ImageFormat.Bmp))
            {
                return ImageFormat.Bmp;
            }
            return ImageFormat.Jpeg;//ʵѡ񷵻ָʽnull
        }

        private void button2_Click(object sender, EventArgs e)
        {
            OpenFileDialog open = new OpenFileDialog();
            if (open.ShowDialog() == DialogResult.OK)
            {
                var filename = open.FileName;

                txt_path.Text = filename;

            }
        }

        private void trackBar2_Scroll(object sender, EventArgs e)
        {
            lab_tb.Text = trackBar2.Value + "%";
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            cb_type.SelectedIndex = 0;

            lab_tb.Text = trackBar2.Value + "%";



            trackBar1.Maximum = Enum.GetValues(typeof(ImageFormatEnum)).Length;
            var m = ImageFormatEnum._1080;
            var index = GetIndex<ImageFormatEnum>((int)m);
            trackBar1.Value = index;
            lab_fbl.Text = (int)m == 0 ? "ԭͼ" : ((int)m).ToString();
        }

        private void trackBar1_Scroll(object sender, EventArgs e)
        {
            var index = trackBar1.Value;
            var en = GetT<ImageFormatEnum>(index);
            lab_fbl.Text = ((int)en).ToString();
        }

        /// <summary>
        /// 
        /// </summary>
        /// <param name="fbl">ֱ</param>
        /// <returns></returns>
        private int GetIndex<T>(int fbl)
        {
            Array arr_enum = Enum.GetValues(typeof(T));
            var index = 0;
            foreach (var myCode in arr_enum)
            {
                if ((int)myCode == fbl)
                {
                    break;
                }
                index++;
            }
            return index;
        }

        private T GetT<T>(int index)
        {
            var indx = 0;
            Array arr_enum = Enum.GetValues(typeof(T));
            T m = (T)Enum.GetValues(typeof(T)).GetValue(0);
            foreach (var myCode in arr_enum)
            {
                if (indx == index)
                {
                    m = (T)myCode;
                    break;
                }
                indx++;
            }
            return m;
        }
    }
}